Imports VB = Microsoft.VisualBasic
Imports System.Version

Module Module1

	Function kuerzen(ByVal q As String) As String
		Dim ret As String
		If Len(q) > 40 Then
			ret = Left(q, 20) + "..." + Right(q, 20)
		Else
			ret = q
		End If
		kuerzen = ret
	End Function
	Function sonderzeichen(ByVal q As String) As String
		Dim ret As String
		Dim i As Integer
		Dim s As String

		ret = ""
		For i = 1 To Len(q)
			s = Mid(q, i, 1)
			If s = ":" Then s = "-"
			If s = "/" Then s = "_"
			If s = "\" Then s = "+"
			ret = ret + s
		Next
		sonderzeichen = ret
	End Function
	Sub Main()
		' Declare variables.
		Dim separators As String = " "
		Dim commands As String = Microsoft.VisualBasic.Command()
		Dim args() As String = commands.Split(separators.ToCharArray)
		Dim c As String

		FileOpen(2, "c:\gs\redmon\pdfmail.log", OpenMode.Append)
		WriteLine(2, "PDFMAIL " + Now.ToString() + " gestartet -------------------------------")
		'REDMON Variablen
		Dim INPUTFILE As String = args(0)
		Dim REDMON_PORT As String = Environ("REDMON_PORT")
		Dim REDMON_JOB As String = Environ("REDMON_JOB")
		Dim REDMON_PRINTER As String = Environ("REDMON_PRINTER")
		Dim REDMON_MACHINE As String = Environ("REDMON_MACHINE")
		Dim REDMON_USER As String = Environ("REDMON_USER")
		Dim REDMON_DOCNAME As String = Environ("REDMON_DOCNAME")
		Dim REDMON_FILENAME As String = Environ("REDMON_FILENAME")
		Dim REDMON_SESSIONID As String = Environ("REDMON_SESSIONID")
		Dim TEMP As String = Environ("TEMP")
		Dim BODYFILE As String
		Dim DATEINAME As String
		Dim REDMON_DOCLANG As String
		REDMON_DOCLANG = REDMON_DOCNAME
		' ungltigen Namen wegkrzen
		REDMON_DOCNAME = kuerzen(REDMON_DOCNAME)
		REDMON_DOCNAME = sonderzeichen(REDMON_DOCNAME)
		' Logdatei
		WriteLine(2, "REDMON_PORT       =" + REDMON_PORT)
		WriteLine(2, "REDMON_JOB        =" + REDMON_JOB)
		WriteLine(2, "REDMON_PRINTER    =" + REDMON_PRINTER)
		WriteLine(2, "REDMON_MACHINE    =" + REDMON_MACHINE)
		WriteLine(2, "REDMON_USER       =" + REDMON_USER)
		WriteLine(2, "REDMON_DOCNAMEorg =" + REDMON_DOCLANG)
		WriteLine(2, "REDMON_DOCNAME    =" + REDMON_DOCNAME)
		WriteLine(2, "REDMON_FILENAME   =" + REDMON_FILENAME)
		WriteLine(2, "REDMON_SESSIONID  =" + REDMON_SESSIONID)
		WriteLine(2, "INPUTFILE         =" + INPUTFILE)
		WriteLine(2, "TEMP              =" + TEMP)

		DATEINAME = TEMP + "\" + REDMON_USER + "-" + REDMON_DOCNAME + "-" + REDMON_JOB
		'c = "c:\gs\gs7.05\bin\gswin32c.exe " _
		c = "-dNOPAUSE -dBATCH -sDEVICE=pdfwrite -dPDFSETTINGS=/printer " _
		+ "-dCompatibilityLevel=1.3 " _
		+ "-sOutputFile=" + Chr(34) + DATEINAME + ".PDF" + Chr(34) + " " _
		+ Chr(34) + INPUTFILE + Chr(34)

		WriteLine(2, Now.ToString() + " Starte gswin32c")
		Dim startInfo As New ProcessStartInfo("c:\gs\gs7.05\bin\gswin32c.exe")
		startInfo.Arguments = c

		startInfo.UseShellExecute = True
		Dim gswin As New System.Diagnostics.Process

		gswin = System.Diagnostics.Process.Start(startInfo)
		gswin.WaitForExit()
		WriteLine(2, Now.ToString() + " gswin32c ist abgelaufen")

		BODYFILE = DATEINAME + ".TXT"

		WriteLine(2, Now.ToString() + " Infodatei wird erzeugt")
		FileOpen(1, BODYFILE, OpenMode.Output)
		WriteLine(1, "Ihr konvertierter PDF-Ausdruck als Anlage")
		WriteLine(1, "Ausdruck erzeugt von: " + REDMON_USER)
		WriteLine(1, "Dokumentname        : " + REDMON_DOCLANG)
		WriteLine(1, "Jobnummer           : " + REDMON_JOB)
		Dim v As New System.Version
		WriteLine(1, "Erstellt von pdfmail " + v.ToString() + " " + Now.ToString())
		FileClose(1)

		c = Chr(34) + BODYFILE + Chr(34) _
		+ " -t " + REDMON_USER + "@stiebel-ms.waldbroel.stiebel.de" _
		+ " -s " + Chr(34) + REDMON_DOCNAME + Chr(34) _
		+ " -attach " + Chr(34) + DATEINAME + ".PDF" + Chr(34) _
			  + " -log c:\gs\redmon\blat.log"

		WriteLine(2, Now.ToString() + " blat wird gestartet")
		Dim blatInfo As New ProcessStartInfo("c:\gs\redmon\blat.exe")
		blatInfo.Arguments = c
		blatInfo.UseShellExecute = True
		Dim blatwin As New System.Diagnostics.Process
		blatwin = System.Diagnostics.Process.Start(blatInfo)
		blatwin.WaitForExit()
		WriteLine(2, Now.ToString() + " blat ist abgelaufen")
		WriteLine(2, Now.ToString() + " Cleanup")
		VB.Kill(DATEINAME + ".*")
		WriteLine(2, "PDFMAIL " + Now.ToString() + " beendet ---------------------------------")
		FileClose(2)
	End Sub

End Module
